<?php

class PoPTheme_Wassup_Core_Bootstrap_CSSResourceLoaderProcessor extends PoP_CSSResourceLoaderProcessor
{
    public const RESOURCE_CSS_MULTISELECT = 'css-multiselect';

    public function getResourcesToProcess()
    {
        return [
            [self::class, self::RESOURCE_CSS_MULTISELECT],
        ];
    }
    
    public function getFilename(array $resource)
    {
        $filenames = array(
            self::RESOURCE_CSS_MULTISELECT => 'multiselect',
        );
        if ($filename = $filenames[$resource[1]]) {
            return $filename;
        }

        return parent::getFilename($resource);
    }
    
    public function getVersion(array $resource)
    {
        return POPTHEME_WASSUPWEBPLATFORM_VERSION;
    }
    
    public function getDir(array $resource)
    {
        $subpath = PoP_WebPlatform_ServerUtils::useMinifiedResources() ? 'dist/' : '';
        return POPTHEME_WASSUPWEBPLATFORM_DIR.'/css/'.$subpath.'templates';
    }
    
    public function getPath(array $resource)
    {
        $subpath = PoP_WebPlatform_ServerUtils::useMinifiedResources() ? 'dist/' : '';
        return POPTHEME_WASSUPWEBPLATFORM_URL.'/css/'.$subpath.'templates';
    }
}


